//			NEW: use  <vector>
//			g++ -Wall -o stl1.cpp
#include <iostream>
#include <cstdlib> 	//	rand()
#include <vector>	// NEW
#include <algorithm>	// NEW  for algorithms used

using namespace std;


int main()
{
 int n;
 cout << " n = "; cin >> n;

 vector<float> x(n);

 //			initialize array
 for (int i=0; i<n; i++)
  {  x[i] = rand() % (i+1) ; }

//############################################################
//			determine maximium (classical)
//############################################################
 float vmax(x[0]);		// good style
 cout << vmax << endl;

 for (int i=1; i<n; i++)
   {  vmax = (vmax > x[i]) ?  vmax : x[i];  }

 cout << "A: Maximum is  " << vmax << endl;

//############################################################
//			determine maximium (vector)
//############################################################
 vmax = x.front();		// first element of vector
 cout << vmax << endl;

 for (unsigned int i=1; i<x.size(); i++)	// NEW: size()
   {  vmax = max(vmax,x[i]);  }			// NEW:

 cout << "B: Maximum is  " << vmax << endl;

//############################################################
//			determine maximium (iterator/pointer)
//############################################################
 vmax = x.front();
 vector<float>::iterator xp;		// NEW: iterator

 for (xp=x.begin(); xp<x.end(); xp++)	// NEW: begin(), end()
   {  vmax = max(vmax,*xp);  }		// (NEW): *xp

 cout << "C: Maximum is  " << vmax << endl;

//############################################################
//			determine maximium - algorithm
//############################################################

 xp = max_element(x.begin(),x.end());	// iterator points to max.
 cout << "D: Maximum is  " << *xp << endl;


 return 0;
}
 
