//				STL/stl5.cpp
#include <iostream>
#include <valarray>	//	valarray [Prinz, p688ff]
using namespace std;

//	Function fuer jedes Vektorelement
double func1(const double& x)
{ return 1./x; }

int main()
{
 int n=10,i;
//cout << " n = "; cin >> n; cout << endl;
//			C-Array 
 double *x = new double[2*n];
 for (i=0; i<2*n; i++)
   { x[i] = (i+1.0)/n; }
 
//			valarray (ohne init) 
 valarray<double> a(n);
//			valarray (const. init) 
 valarray<double> b(3.14579, n);
//			valarray (c-vektor init) 
 valarray<double> c(x+n/2, n); 
//			Controllausgabe
 for (i=0; i<c.size(); i++)
   {cout << i << " : " << c[i] << endl; }
 cout << endl;
//			Multiplikation 
 a = b*c;
 a = a.apply(func1);	// Funktion  func1 anwenden
//			Controllausgabe
 for (i=0; i<a.size(); i++)
   {cout << i << " : " << a[i] << endl; }   
  cout << endl;
 cout << " sum = " << a.sum() << endl;

//	indirekte Adressierung
 valarray<size_t> idx(5);
 idx[0] = 3;
 idx[1] = 1;
 idx[2] = 4;
 idx[3] = 3;
 idx[4] = 0;
 
 valarray<double> d( a[idx] );
 for (i=0; i<d.size(); i++)
   {cout << i << " : " << d[i] << endl; }   
  cout << endl;

//	mit stride: holt a[1], a[3], a[5]
 valarray<double> asl( a[ slice(1,3,2) ] ); 
 for (i=0; i<asl.size(); i++)
   {cout << i << " : " << asl[i] << endl; }   
  cout << endl;

//	Finde alle Elemente in a, die kleiner als 0.3 sind.
 valarray<bool>  bb( a < 0.3 );  // boolean vector
for (i=0; i<bb.size(); i++)
   {cout << i << " : " << bb[i] << endl; }   
  cout << endl;  

//	Finde alle Elemente in a, die groesser als 0.3 sind
//		und speichere diese in einem neuen Vektor
 valarray<double>  abc( a[a > 0.3] ); 
for (i=0; i<abc.size(); ++i)
   {cout << i << " : " << abc[i] << endl; }   
  cout << endl;  
        
        
 return 0;
}

 
